using SqlSugar;
using System.ComponentModel;
using Txgy.RBS.IServices;
using Txgy.RBS.Server.WebApi.Register;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.

builder.Register(); //ҵ߼ע 
//֧Automapperӳ
builder.Services.AddAutoMapper(typeof(AutoMapObject));

builder.Services.AddControllers();
// Learn more about configuring Swagger/OpenAPI at https://aka.ms/aspnetcore/swashbuckle
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();
 //sqlsugar
 builder.Services.AddTransient<ISqlSugarClient>(context =>
            {
               string con = builder.Configuration.GetConnectionString("ConnectionSqlite");
                SqlSugarClient client = new SqlSugarClient(new ConnectionConfig()
                {
                    ConnectionString = builder.Configuration.GetConnectionString("ConnectionSqlite"),
                    DbType = DbType.Sqlite,
                    InitKeyType = InitKeyType.Attribute,
                });
                //֧sqlų
                client.Aop.OnLogExecuting = (sql, par) =>
                {
                    Console.WriteLine("\r\n");
                    Console.WriteLine($"Sql:{sql}");
                    Console.WriteLine($"======================================================================");
                };
                return client;
            });

var app = builder.Build();

// Configure the HTTP request pipeline.
if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();

app.Run();
